package naca4builder;

class NACAPoint {

    public double x = 0;
    public double y = 0;
    public double x0 = 0;
    public double y0 = 0;
    public double dx = 0;
    public double dy = 0;
    public double l = 0;
    public double s = 0;
    public double maxy = 0;
    public double maxyx = 0;
    NACAPoint next;
    NACAPoint source;

    NACAPoint() {
        next = null;
        source = null;
    }

    NACAPoint(NACAPoint source) {
        next = source.next;
        source.next = this;
        this.source = source;
    }

    protected void done() {
        assert dx > 0;
        if (next != null) {
            next.calc();
        }
        x0 = x;
        y0 = y;
    }

    public double fi() {
        assert dx > 0;
        return Math.atan2(dy, dx);
    }

    void calc() {
        dx = x - x0;
        dy = y - y0;
        doStat();
        done();
    }

    protected void doStat() {
        s += dx * (y + y0) / 2;
        l += Math.sqrt(dx * dx + dy * dy);
        if (y > maxy) {
            maxy = y;
            maxyx = x;
        }
    }
}
