package naca4builder;

class NACAcamberline extends NACAPoint {

    Main foil;

    NACAcamberline(NACAPoint base, Main foil) {
        super(base);
        this.foil = foil;
    }

    void calc() {
        x = source.x;
        if (foil.chambered) {
            if (x <= foil.p) {
                y = foil.m * x / (foil.p * foil.p) * (2 * foil.p - x);
            } else {
                y = foil.m * (1 - x) / ((1 - foil.p) * (1 - foil.p)) * (1 + x - 2 * foil.p);
            }
        }
        super.calc();
    }
}
